#include "ArVizDrawerBase.h"

#include "RobotAPI/components/ArViz/Client/Client.h"
#include "RobotAPI/components/ArViz/Client/Layer.h"

namespace armarx
{

    ArVizDrawerBase::ArVizDrawerBase(armarx::viz::Client& arviz) : arvizClient(arviz) {}

    ArVizDrawerBase::~ArVizDrawerBase() = default;

    viz::ScopedClient& ArVizDrawerBase::arviz()
    {
        return arvizClient;
    }

    const viz::ScopedClient& ArVizDrawerBase::arviz() const
    {
        return arvizClient;
    }

    void ArVizDrawerBase::commit(const viz::Layer& layer)
    {
        std::lock_guard guard{layerMtx};
        arvizClient.commit(layer);
    }

    void ArVizDrawerBase::commit(const std::vector<viz::Layer>& layers)
    {
        std::lock_guard guard{layerMtx};
        arvizClient.commit(layers);
    }

} // namespace armarx
