#include <RobotAPI/libraries/armem/client/ReaderComponentPlugin.h>


// ArmarX
#include <ArmarXCore/core/Component.h>
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

// RobotAPI
#include <RobotAPI/libraries/armem/core/error.h>


namespace armarx::armem::client::plugins
{
    ReaderComponentPlugin::ReaderComponentPlugin(ManagedIceObject& parent, std::string pre) :
        ComponentPlugin(parent, pre)
    {
        addPlugin(mnsPlugin, pre);
        addPluginDependency(mnsPlugin);
    }


    ReaderComponentPlugin::~ReaderComponentPlugin()
    {
    }
}



namespace armarx::armem::client
{
    ReaderComponentPluginUser::ReaderComponentPluginUser()
    {
        addPlugin(plugin);
    }


    ReaderComponentPluginUser::~ReaderComponentPluginUser()
    {
    }


    void
    ReaderComponentPluginUser::setReadingMemoryServer(server::ReadingMemoryInterfacePrx memory)
    {
        memoryReader.setReadingMemory(memory);
    }


    armem::data::WaitForMemoryResult ReaderComponentPluginUser::useMemoryServer(const std::string& memoryName)
    {
        armem::data::WaitForMemoryResult result;
        result.proxy = memoryNameSystem.useServer(memoryName);
        if (result.proxy)
        {
            setReadingMemoryServer(result.proxy);
        }
        return result;
    }

}
