#pragma once

#include "BaseQueryProcessor.h"
#include "../base/ProviderSegmentQueryProcessorBase.h"

#include "../../../core/diskmemory/ProviderSegment.h"

#include "EntityQueryProcessor.h"

namespace armarx::armem::d_ltm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class ProviderSegmentQueryProcessor :
        virtual public BaseQueryProcessor<d_ltm::ProviderSegment, armem::query::data::ProviderSegmentQuery>,
        virtual public base::query_proc::ProviderSegmentQueryProcessorBase<d_ltm::ProviderSegment>
    {
        using Base = BaseQueryProcessor<d_ltm::ProviderSegment, armem::query::data::ProviderSegmentQuery>;

    public:
        ProviderSegmentQueryProcessor() :
            Base()
        {}

    protected:
        virtual EntityT entityProcessorProcess(const armem::query::data::EntityQuerySeq& q, const EntityT& s) const override
        {
            return entityProcessor.process(q, s);
        }

    private:
        EntityQueryProcessor entityProcessor;

    };

}
