#include "CoreSegmentQueryProcessor.h"

#include <RobotAPI/libraries/armem/core/workingmemory/ice_conversions.h>


namespace armarx::armem::wm::query_proc
{

    CoreSegmentQueryProcessor::CoreSegmentQueryProcessor(DataMode dataMode) :
        Base(dataMode), providerSegmentProcessor(dataMode)
    {}


    CoreSegmentQueryProcessor::~CoreSegmentQueryProcessor() = default;


    void CoreSegmentQueryProcessor::process(
        CoreSegment& result, const armem::query::data::CoreSegmentQuery& query, const CoreSegment& coreSegment) const
    {
        std::scoped_lock lock(coreSegment.mutex());
        CoreSegmentQueryProcessorBase::process(result, query, coreSegment);
    }


    data::CoreSegment CoreSegmentQueryProcessor::processToIce(const armem::query::data::CoreSegmentQuery& query, const wm::CoreSegment& coreSegment) const
    {
        data::CoreSegment data;
        toIce(data, process(query, coreSegment));
        return data;
    }


    ProviderSegment CoreSegmentQueryProcessor::providerSegmentProcessorProcess(const armem::query::data::ProviderSegmentQuerySeq& q, const ProviderSegment& s) const
    {
        return providerSegmentProcessor.process(q, s);
    }


}
