#pragma once

#include <mutex>

#include <RobotAPI/libraries/armem/core/workingmemory/CoreSegment.h>
#include <RobotAPI/libraries/armem/server/query_proc/base/CoreSegmentQueryProcessorBase.h>

#include "BaseQueryProcessor.h"
#include "ProviderSegmentQueryProcessor.h"


namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class CoreSegmentQueryProcessor :
        virtual public BaseQueryProcessor<wm::CoreSegment, armem::query::data::CoreSegmentQuery>,
        virtual public base::query_proc::CoreSegmentQueryProcessorBase<wm::CoreSegment>
    {
        using Base = BaseQueryProcessor<wm::CoreSegment, armem::query::data::CoreSegmentQuery>;

    public:

        CoreSegmentQueryProcessor(DataMode dataMode = DataMode::WithData);
        virtual ~CoreSegmentQueryProcessor() override;

        using Base::process;

        /// Locks the core segment, then delegates back to `CoreSegmentQueryProcessorBase`.
        void process(CoreSegment& result,
                     const armem::query::data::CoreSegmentQuery& query,
                     const CoreSegment& coreSegment) const override;

        data::CoreSegment processToIce(const armem::query::data::CoreSegmentQuery& query, const wm::CoreSegment& coreSegment) const;


    protected:

        virtual ProviderSegment providerSegmentProcessorProcess(const armem::query::data::ProviderSegmentQuerySeq& q, const ProviderSegmentT& s) const override;


    private:

        ProviderSegmentQueryProcessor providerSegmentProcessor;

    };
}
