#include "EntityQueryProcessor.h"

#include <RobotAPI/libraries/armem/core/workingmemory/ice_conversions.h>


namespace armarx::armem::wm::query_proc
{
    EntityQueryProcessor::EntityQueryProcessor(DataMode dataMode) :
        BaseQueryProcessor<wm::Entity, armem::query::data::EntityQuery>(dataMode)
    {}


    EntityQueryProcessor::~EntityQueryProcessor() = default;


    void EntityQueryProcessor::addResultSnapshot(wm::Entity& result, const wm::EntitySnapshot& snapshot) const
    {
        bool withData = (dataMode == DataMode::WithData);
        if (withData)
        {
            result.addSnapshot(snapshot.copy());
        }
        else
        {
            result.addSnapshot(snapshot.copyWithoutData());
        }
    }


    data::Entity EntityQueryProcessor::processToIce(const armem::query::data::EntityQuery& query, const wm::Entity& entity) const
    {
        data::Entity data;
        toIce(data, process(query, entity));
        return data;
    }


    void EntityQueryProcessor::addResultSnapshot(wm::Entity& result, wm::Entity::ContainerT::const_iterator it) const
    {
        addResultSnapshot(result, it->second);
    }

}
