#pragma once

#include <RobotAPI/libraries/armem/core/workingmemory/Memory.h>
#include <RobotAPI/libraries/armem/server/query_proc/base/MemoryQueryProcessorBase.h>

#include "BaseQueryProcessor.h"

#include "CoreSegmentQueryProcessor.h"


namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class MemoryQueryProcessor :
        virtual public BaseQueryProcessor<wm::Memory, armem::query::data::MemoryQuery>,
        virtual public base::query_proc::MemoryQueryProcessorBase<wm::Memory>
    {
        using Base = BaseQueryProcessor<wm::Memory, armem::query::data::MemoryQuery>;

    public:

        MemoryQueryProcessor(DataMode dataMode = DataMode::WithData);
        virtual ~MemoryQueryProcessor() override;


    protected:

        virtual CoreSegment coreSegmentProcessorProcess(
            const armem::query::data::CoreSegmentQuerySeq& q, const CoreSegment& s) const override;


    private:

        CoreSegmentQueryProcessor coreSegmentProcessor;

    };
}
