#pragma once

#include <RobotAPI/libraries/armem/core/workingmemory/ProviderSegment.h>
#include <RobotAPI/libraries/armem/server/query_proc/base/ProviderSegmentQueryProcessorBase.h>

#include "BaseQueryProcessor.h"
#include "EntityQueryProcessor.h"


namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class ProviderSegmentQueryProcessor :
        virtual public BaseQueryProcessor<wm::ProviderSegment, armem::query::data::ProviderSegmentQuery>,
        virtual public base::query_proc::ProviderSegmentQueryProcessorBase<wm::ProviderSegment>
    {
        using Base = BaseQueryProcessor<wm::ProviderSegment, armem::query::data::ProviderSegmentQuery>;

    public:

        ProviderSegmentQueryProcessor(DataMode dataMode = DataMode::WithData);
        virtual ~ProviderSegmentQueryProcessor() override;


        using Base::process;
        data::ProviderSegment processToIce(const armem::query::data::ProviderSegmentQuery& query, const wm::ProviderSegment& providerSegment) const;


    protected:

        virtual Entity entityProcessorProcess(const armem::query::data::EntityQuerySeq& q, const Entity& s) const override;

    private:

        EntityQueryProcessor entityProcessor;

    };
}
